using System.Runtime.InteropServices;

namespace VALCam_SDK_2005_Sample_1
{
    partial class Form1
    {
        [StructLayout(LayoutKind.Sequential)]
        public struct  structFaceFinder
        {
            public float FacePositionX;
            public float FacePositionY;
            public float EyeDistance;
            public int Glasses;
            public int EyesOpen;
            public int MouthClosed;
            public float FaceWidth;
            public float FaceHeight;
            public int ImageWidth;
            public int ImageHeight;
            float FaceConfidence;
            float Eye1Confidence;
            float Eye2Confidence;
           
            public int FaceFound;
            public int AutoCenter;
            public int OffsetX;
            public int OffsetY;
            
            public string FileName;
            public int SampleFromStream;
        };

       
        public struct structCaptureConfiguration
        {

           public int Shaprness;  //values 0 - 900, 400 default if 0
           public int PreviewCapture; //0 - No Preview, 1 Preview Capture
           public string FileName; //Full path and file name;
           public int CaptureType; //0-DIB, 1-DDB, 2-Clipboard, 3-BMP, 4-JPG
           public int JpgCompression;// 1-Min Compression, 255-Max Compression
           public int FlashOn;//0-Flash Off, 1- Flash On
          // public int DisplayHandle;
         //  public int DisplayX;
         //  public int DisplayY;
        }

        public struct structReturnValues
        {
            public int ReturnLiveRed;
            public int ReturnLiveBlue;
            public int ReturnLiveColor;
            public int ReturnFlashRed;
            public int ReturnFlashBlue;
            public int ReturnFlashColor;
            public int ReturnFlashIris;
            public int ReturnSharpness;
            public int ReturnFGSharpness;
            public int ReturnAutoWhite;
            public int ReturnRedPaint;
            public int ReturnBluePaint;
            public int ReturnCropStartX;
            public int ReturnCropStartY;
            public int ReturnCaptureCropHeight;
            public int ReturnFlashCorrection;
            public int ReturnZoomArray;
            public int ReturnLiveIrisLevel;
            public int ReturnRedColorCorrect;
            public int ReturnBlueColorCorrect;
        };






        //****************** References for External Win32 DLLs******************************************
        [DllImport("USB_SDK.Dll")]
        public static extern int VALCam_Control(int Msg, int Param1, int Param2, int Param3, int Param4);

       
        
       // [System.Runtime.InteropServices.DllImport("Kernel32.Dll", EntryPoint="GetConsoleCursorInfo
        [DllImport("USB_SDK.Dll")]
        public static extern void VALCam_FaceFinder(ref structFaceFinder Test);

        [DllImport("USB_SDK.Dll",CharSet=CharSet.Auto)]
        public static extern int VALCam_Capture(ref structCaptureConfiguration CaptureStruct);

        [DllImport("USB_SDK.Dll")]
        public static extern int VALCam_ReadReturnParameters(ref structReturnValues ReturnValues);
        
        [DllImport("kernel32.dll")]
        public static extern int GlobalFree(int hMem);

        [DllImport("Gdi32.dll")]
        public static extern bool DeleteObject(int hBitmap);

        [DllImport("User32")]
        public static extern int GetSystemMetrics(int Index);




        //******************* End of External Win32 Dll References ***************************************

       public static structFaceFinder FaceParameters,FaceParameters1;
       public static structCaptureConfiguration CaptureConfiguration;
       public static structReturnValues ReturnValues;

        //************ Definitions for SDK Command Constants ***********************************************

        public static    int VC_InitSystem = 0;
        public static    int VC_DisplayVideo = 1;
        public static    int VC_Freeze = 2;
        public static    int VC_NoVideoDisplay = 3;
        public static    int VC_LiveCapture = 4;
        public static    int VC_SetFlashIrisLevel = 5;
        public static    int VC_FastCapture = 200;
        public static    int VC_SendWindowHandle = 6;
        public static    int VC_FlashCapture = 7;
        public static    int VC_ScaleCapturedImage = 18;

        public static    int VC_TiltUp = 8;
        public static    int VC_TiltUpSlow = 218;
        public static    int VC_TiltUpFast = 224;

        public static    int VC_TiltDown = 9;
        public static    int VC_TiltDownSlow = 219;
        public static    int VC_TiltDownFast = 225;


        public static    int VC_PanLeft = 10;
        public static    int VC_PanLeftSlow = 220;
        public static    int VC_PanLeftFast = 226;


        public static    int VC_PanRight = 11;
        public static    int VC_PanRightSlow = 221;
        public static    int VC_PanRightFast = 227;

        public static    int VC_ZoomIn = 13;
        public static    int VC_ZoomInSlow = 222;
        public static    int VC_ZoomInFast = 228;


        public static    int VC_ZoomOut = 14;
        public static    int VC_ZoomOutSlow = 223;
        public static    int VC_ZoomOutFast = 229;
        public static    int VC_ZoomArray = 230;

        public static    int VC_PanTiltStop = 12;
        public static    int VC_ZoomStop = 15;

        public static    int VC_SaveIniFile = 17;
        public static    int VC_CloseCard = 20;

        public static    int VC_LiveIrisUp = 42;
        public static    int VC_LiveIrisDown = 43;
        public static    int VC_SetLiveBrightness = 132;
        public static    int VC_ReturnLiveBrightness = 133;



        public static    int VC_ReturnLiveRed = 31;
        public static    int VC_ReturnLiveBlue = 32;
        public static    int VC_ReturnLiveColor = 33;
        public static    int VC_ReturnFlashRed = 34;
        public static    int VC_ReturnFlashBlue = 35;
        public static    int VC_ReturnFlashColor = 36;
        public static    int VC_ReturnFlashIris = 39;
        public static    int VC_ReturnCaptureSharpness = 130;
        public static    int VC_ReturnFrameGrabberSharpness = 131;
        public static    int VC_ReturnCroppingWidth = 152;
        public static    int VC_ReturnCroppingHeight = 153;
        public static    int VC_ReturnFlashColorCorrectionType = 157;
        public static    int VC_ReturnAutoWhite = 134;
        public static    int VC_ReturnRedPaint = 135;
        public static    int VC_ReturnBluePaint = 136;
        public static    int VC_ReturnZoomArray = 158;
        public static    int VC_ReturnExposureComp = 159;
        public static    int VC_ReturnDistance = 167;
        public static    int VC_ReturnDistanceAccurate = 168;
        public static    int VC_ReturnZoomPixelIncrement = 169;

        public static    int VC_SetRedLive = 110;
        public static    int VC_SetBlueLive = 111;
        public static    int VC_SetColorLive = 112;
        public static    int VC_SetRedFlash = 113;
        public static    int VC_SetBlueFlash = 114;
        public static    int VC_SetColorFlash = 115;
        public static    int VC_AutoWhite = 118;  //New Command Added on 4-1-06
        public static    int VC_SetFlashColorCorrectionType = 119;// Set for different types of lighting

        public static    int VC_SetFrameGrabberSharpness = 120;


        public static    int VC_SetPreviewDefaults = 27;
        public static    int VC_SetFlashDefaults = 28;

        public static    int VC_SetCropParameters = 156;

        public static    int VC_ReadZoomPosition = 300;
        public static    int VC_ReadPanPosition = 301;
        public static    int VC_ReadTiltPosition = 302;
        public static    int VC_SetZoomPosition = 303;

        public static    int VC_SetPanTiltCenter = 305;
        public static    int VC_SetPTZPosition = 304;

        public static    int VC_RotateLiveDisplay = 250;

        public static    int VC_MessageDrainHnd = 21;
        public static    int VC_DisplayCapture = 22;
        public static    int VC_SaveCapturedImage = 23;
        public static    int VC_ColorCorrectImage = 24;
        public static    int VC_DiscardPreviewImage = 25;
        public static    int VC_VerifySystemInitialized = 600;



        //******************* Variable Definitions **************************************************************** 
        public static int ErrorLevel;
        public static int
            iHScale, iVScale, //Size of displayed image 
            iColorGain, iRedGain, iBlueGain, //Live Color Parameters
            iFlashColorGain, iFlashRedGain, iFlashBlueGain, //Flash Color Parameters
            iFlashIrisLevel,  // Flash intensity
            FGSharpness, iCaptureSharpness, //Sharpness Values 
            iVSize, iHSize, iXCropStart, iYCropStart, //Crop Values
            iZoomArray, // 0-50 Zoom value
            iPTZSpeed, //PTZ speed
            iPreview, iFlash, iAutoWhite,//Preview, Flash and Autowhite On/Off
            iLiveBrightnessLevel, //Live Exposure Level
            iFlashCorrectionType, //Flash Flourscent Correction
            iRedColorCorrect, iBlueColorCorrect, //After capture color Controls
            iCaptureType = 5, iJPGCompression=25,// Type of Image to capture and JPG Compression  
            iXCenterOffset = 0, iYCenterOffset = 0,
            iRotatePosition = 0;
        
        
        public static string iFileName= "c:\\NMImage.jpg";
        public static int MouseClick = 0;
        public static bool bPreview;
        public static bool bFlash;
        public static bool bAdjustDialogOpen = false;
        public static bool bAdjustZoomDialogOpen = false;
        public static bool bDialogOpen = false;
        public static int iScreenXResolution, iScreenYResolution;
        public static int HANDLE;


        AdjustZoom dlgAdjustZoom;
        AdjustFlashBrightness dlgAdjustFlashBrightness;
        AdjustFlashColor dlgAdjustFlashColor;
        LiveAdjustments dlgLiveAdjustments;


        
    }
}
